diff a/src/hotspot/share/cds/cdsEnumKlass.hpp b/src/hotspot/share/cds/cdsEnumKlass.hpp
--- a/src/hotspot/share/cds/cdsEnumKlass.hpp
+++ b/src/hotspot/share/cds/cdsEnumKlass.hpp
@@ -28,23 +28,27 @@
 #include "memory/allStatic.hpp"
 #include "oops/oop.hpp"
 #include "utilities/exceptions.hpp"
 #include "utilities/macros.hpp"
 
+class fieldDescriptor;
 class InstanceKlass;
 class JavaFieldStream;
 class KlassSubGraphInfo;
 
 class CDSEnumKlass: AllStatic {
 public:
   static bool is_enum_obj(oop orig_obj);
-  static void handle_enum_obj(int level,
-                              KlassSubGraphInfo* subgraph_info,
-                              oop orig_obj);
+  static void archive_enum_obj(int level,
+                               KlassSubGraphInfo* subgraph_info,
+                               oop orig_obj);
   static bool initialize_enum_klass(InstanceKlass* k, TRAPS) NOT_CDS_JAVA_HEAP_RETURN_(false);
 
 private:
-  static void archive_static_field(int level, KlassSubGraphInfo* subgraph_info,
-                                   InstanceKlass* ik, oop mirror, JavaFieldStream& fs);
+  static void archive_static_oop_field(int level, KlassSubGraphInfo* subgraph_info,
+                                       InstanceKlass* ik, oop mirror, fieldDescriptor& fd);
+  static void archive_static_primitive_field(int level, KlassSubGraphInfo* subgraph_info,
+                                             InstanceKlass* ik, oop mirror, fieldDescriptor& fd);
+  static bool can_archive_static_oop_field(InstanceKlass* enum_klass, oop obj);
 };
 
 #endif // SHARE_CDS_CDSENUMKLASS_HPP
